<template>
    <q-card style="min-width: 500px">
        <q-card-section>
            <div class="text-h6">Create Appointment</div>
        </q-card-section>

        <q-card-section class="q-pt-none">
            <!-- User -->
            <p class="font-14 q-my-md helvetica-neue-medium">
                {{ $t('appointment.selectUser') }}
                <span class="text-ff0000 font-10" v-if="!state.user">
                    {{ $t('form.required') }}
                </span>
            </p>

            <q-select
                :disable="conversationList"
                filled
                v-model="state.user"
                use-input
                :options="state.clientOptions"
                @filter="filterUser"
                input-debounce="500"
                clearable
                option-value="id"
                option-label="name"
            >
                <template v-slot:no-option>
                    <q-item>
                        <q-item-section class="text-grey">
                            No results
                        </q-item-section>
                    </q-item>
                </template>
            </q-select>

            <!-- Selected Date -->
            <!-- Start Time -->
            <p class="font-14 q-my-md helvetica-neue-medium">
                {{ $t('appointment.startDateNTime') }}
                <span class="text-ff0000 font-10" v-if="!state.start">
                    {{ $t('form.required') }}
                </span>
            </p>
            <q-input filled v-model="state.start">
                <template v-slot:prepend>
                    <q-icon name="event" class="cursor-pointer">
                        <q-popup-proxy
                            cover
                            transition-show="scale"
                            transition-hide="scale"
                        >
                            <q-date
                                v-model="state.start"
                                mask="YYYY-MM-DD HH:mmA"
                            >
                                <div class="row items-center justify-end">
                                    <q-btn
                                        v-close-popup
                                        label="Close"
                                        color="primary"
                                        flat
                                    />
                                </div>
                            </q-date>
                        </q-popup-proxy>
                    </q-icon>
                </template>

                <template v-slot:append>
                    <q-icon name="access_time" class="cursor-pointer">
                        <q-popup-proxy
                            cover
                            transition-show="scale"
                            transition-hide="scale"
                        >
                            <q-time
                                v-model="state.start"
                                mask="YYYY-MM-DD hh:mmA"
                                format12h
                            >
                                <div class="row items-center justify-end">
                                    <q-btn
                                        v-close-popup
                                        label="Close"
                                        color="primary"
                                        flat
                                    />
                                </div>
                            </q-time>
                        </q-popup-proxy>
                    </q-icon>
                </template>
            </q-input>

            <!-- End Time -->
            <p class="font-14 q-my-md helvetica-neue-medium">
                {{ $t('appointment.endTime') }}
                <span class="text-ff0000 font-10" v-if="!state.endTime">
                    {{ $t('form.required') }}
                </span>
            </p>
            <q-input filled v-model="state.endTime">
                <template v-slot:append>
                    <q-icon name="access_time" class="cursor-pointer">
                        <q-popup-proxy
                            cover
                            transition-show="scale"
                            transition-hide="scale"
                        >
                            <q-time
                                v-model="state.endTime"
                                mask="hh:mm A"
                                format12h
                            >
                                <div class="row items-center justify-end">
                                    <q-btn
                                        v-close-popup
                                        label="Close"
                                        color="primary"
                                        flat
                                    />
                                </div>
                            </q-time>
                        </q-popup-proxy>
                    </q-icon>
                </template>
            </q-input>

            <!-- Remark -->
            <p class="font-14 q-my-md helvetica-neue-medium">
                {{ $t('appointment.remark') }}
            </p>
            <q-input
                v-model="state.remark"
                filled
                @keyup.enter="state.appointmentDialog = false"
            />

            <!-- Service Type -->

            <p class="font-14 q-my-md helvetica-neue-medium">
                {{ $t('appointment.serviceTypes') }}
                <span class="text-ff0000 font-10" v-if="!state.serviceTypes">
                    {{ $t('form.required') }}
                </span>
            </p>

            <q-select
                filled
                v-model="state.serviceTypes"
                :options="state.serviceTypesOptions"
                multiple
                map-options
                emit-value
                use-chips
                option-value="id"
                :option-label="
                    (item) =>
                        item.childName
                            ? item.name + ' - ' + item.childName
                            : item.name
                "
            >
                <template v-slot:option-label="services">
                    {{ services.opt.name }} -
                    {{ services.opt.childName }}
                </template>
                <template v-slot:option="services">
                    <q-item v-bind="services.itemProps">
                        <q-item-section v-if="services.opt.childName">
                            <q-item-label>
                                {{ services.opt.name }} -
                                {{ services.opt.childName }}
                            </q-item-label>
                        </q-item-section>
                        <q-item-section v-else>
                            <q-item-label>
                                {{ services.opt.name }}
                            </q-item-label>
                        </q-item-section>
                    </q-item>
                </template>
                <template v-slot:no-option>
                    <q-item>
                        <q-item-section class="text-grey">
                            No results
                        </q-item-section>
                    </q-item>
                </template>
            </q-select>
        </q-card-section>

        <q-card-actions align="right" class="text-primary">
            <q-btn flat label="Cancel" v-close-popup />
            <q-btn
                flat
                label="Create"
                v-close-popup
                @click="createAppointment"
            />
        </q-card-actions>
    </q-card>
</template>

<script lang="ts">
/* eslint-disable @typescript-eslint/no-unsafe-call */
/* eslint-disable @typescript-eslint/no-unsafe-member-access */
/* eslint-disable @typescript-eslint/no-unsafe-assignment */
/* eslint-disable @typescript-eslint/no-explicit-any*/
/* eslint-disable @typescript-eslint/no-floating-promises */
/* eslint-disable @typescript-eslint/no-misused-promises */
/* eslint-disable @typescript-eslint/require-await */
/* eslint-disable @typescript-eslint/restrict-template-expressions */
/* eslint-disable @typescript-eslint/no-implicit-any-catch */

import { defineComponent, reactive, ref, onMounted, computed } from 'vue';
import { useStore } from 'src/store';

export default defineComponent({
    name: 'AppointmentDialog',
    props: {
        conversationList: {
            type: Boolean,
            default: () => false
        }
    },
    setup(props) {
        const store = useStore();

        const pagination = computed(() => {
            return store.state.appointment.appointmentsPagination;
        });

        let state = reactive({
            appointmentDialog: ref(false),
            currentPage: 1,
            selectedClient: {} as any,
            reset: ref(false),
            start: '' as any,
            endTime: '' as any,
            user: '' as any,
            serviceTypes: ref([]),
            clientOptions: ref([]),
            serviceTypesOptions: ref([]),
            remark: '' as any
        });

        const getUserList = async () => {
            const result: any = await store.dispatch('business/getCustomer');

            const options: any = [];

            if (result) {
                result.customers.forEach((element: any) => {
                    let results = {
                        id: element.id,
                        name: element.name
                    };
                    options.push(results);
                });

                state.clientOptions = options;

                if (props.conversationList) {
                    state.user =
                        store.state.conversation.selectedConversation?.user;
                }
            }
        };

        const filterUser = (val: any, update: any) => {
            update(async () => {
                if (val != '') {
                    let query = {
                        page: state.currentPage,
                        keyword: val,
                        limit: 20
                    };
                    const result: any = await store.dispatch(
                        'business/getCustomer',
                        query
                    );

                    const options: any = [];

                    if (result) {
                        result.customers.forEach((element: any) => {
                            let results = {
                                id: element.id,
                                name: element.name
                            };
                            options.push(results);
                        });

                        state.clientOptions = options;
                    }
                } else {
                    getUserList();
                }
            });
        };

        const filterServiceTypes = async (val?: any) => {
            let query = {
                businessId: store.state.business.businessID,
                page: state.currentPage,
                keyword: val,
                limit: 20
            };

            const result: any = await store.dispatch(
                'service/getServiceTypeList',
                query
            );

            const options: any = [];

            let service = {
                id: '' as string,
                name: '' as string,
                childName: '' as string
            };

            // Will get parent id, if don't have child
            const data: any = result.result;
            if (data) {
                data.serviceTypes.forEach((element: any) => {
                    if (element.parentId == null) {
                        service = {
                            id: element.id,
                            name: element.name,
                            childName: ''
                        };
                        options.push(service);
                    }
                    data.serviceTypes.forEach((element2: any) => {
                        if (element2.parentId == element.id) {
                            service = {
                                id: element2.id,
                                name: element.name,
                                childName: element2.name
                            };
                            options.push(service);
                        }
                    });
                });

                state.serviceTypesOptions = options;
            }
        };

        const createAppointment = async () => {
            var datetime = state.start.split(' ');

            const body = {
                userId: state.user.id,
                selectedDate: datetime[0],
                startTime: datetime[1],
                endTime: state.endTime,
                remark: state.remark,
                serviceTypeIds: state.serviceTypes
            };

            await store.dispatch('appointment/createAppointment', body);

            clearField();
        };

        const clearField = () => {
            state.start = '';
            state.endTime = '';
            state.user = '';
            state.remark = '';
            state.serviceTypes = [];
            state.clientOptions = [];
        };

        // Mounted
        onMounted(filterServiceTypes);
        onMounted(getUserList);

        return {
            state,
            tab: ref('add'),
            filterUser,
            filterServiceTypes,
            createAppointment,
            pagination
        };
    }
});
</script>
